---
stages:
  - pre-commit
  - test-suite
  - pop-release

include:
  - project: saltstack/pop/cicd/ci-templates
    file: /lint/pre-commit-run-all-py39.yml
  - project: saltstack/pop/cicd/ci-templates
    file: /release/pop_release.yml

variables:
  CICD_UPSTREAM_PATH: "vmware/idem/pytest-idem"

.test-suite:
  stage: test-suite
  needs:
    - pre-commit-run-all
  script:
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv
  artifacts:
    when: always
    paths:
      - artifacts
    reports:
      junit: artifacts/junit-report.xml
    expire_in: 30 days

tests-3.8:
  extends: .test-suite
  image: python:3.8

tests-3.9:
  extends: .test-suite
  image: python:3.9

tests-3.9-macos1015:
  extends: .test-suite
  tags:
    - vmw-macos-catalina

#tests-3.9-windows1021H2:
# extends: .test-suite
# tags:
#   - shared-windows
# script:
#   - choco install python --version=3.9.4 -y -f
#   - C:\\Python39\\python.exe -m pip install nox
#   - C:\\Python39\\Scripts\\nox.exe -e tests-3 -- -vv

tests-3.10:
  extends: .test-suite
  image: python:3.10

tests-3.11:
  extends: .test-suite
  image: python:3.11
